import { Component, Prop, Element, Watch } from "@stencil/core";
export class ItemMetadata {
    updatePieApilive() {
        var _a;
        if (this._key && this.attribute) {
            const newMeta = { key: this._key, attribute: this.attribute };
            const pieLive = this.el.closest("pie-api-live");
            const metadata = (_a = pieLive.metadata) !== null && _a !== void 0 ? _a : [];
            if (!metadata.includes(newMeta)) {
                metadata.push({ key: this._key, attribute: this.attribute });
                pieLive.metadata = metadata;
            }
        }
    }
    componentWillLoad() {
        this.updatePieApilive();
    }
    static get is() { return "item-metadata"; }
    static get properties() { return {
        "_key": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": "The key for the metadata value to look up for an item in pie-api"
            },
            "attribute": "key",
            "reflect": false
        },
        "attribute": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": "The attribute name to use - the value returned for the metadat key will be placed in this attribute on child `<pie-live-session>` elements."
            },
            "attribute": "attribute",
            "reflect": false
        }
    }; }
    static get elementRef() { return "el"; }
    static get watchers() { return [{
            "propName": "_key",
            "methodName": "updatePieApilive"
        }, {
            "propName": "attribute",
            "methodName": "updatePieApilive"
        }]; }
}
