import { Component, h, Listen, State, Element, Watch, Prop } from '@stencil/core';
import { loadAggregateElement } from "../../response-loader/aggregates-loader";
export class PieAggregate {
    constructor() {
        this.aggregateData = { loaded: false };
    }
    watchAggregateId() {
    }
    watchAggregateData() {
    }
    itemAggregateHandler(event) {
        if (event.detail.aggregateId === this.aggregateId) {
            this.aggregateData = event.detail;
            this.aggregateData.loaded = true;
        }
    }
    render() {
        loadAggregateElement("aggregate", this.aggregateData, this.el);
        return (h("div", null, "Aggregate"));
    }
    static get is() { return "pie-aggregate"; }
    static get encapsulation() { return "shadow"; }
    static get properties() { return {
        "aggregateId": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": "The Aggregator Id to receive events to"
            },
            "attribute": "aggregate-id",
            "reflect": true
        }
    }; }
    static get states() { return {
        "aggregateData": {}
    }; }
    static get elementRef() { return "el"; }
    static get watchers() { return [{
            "propName": "aggregateId",
            "methodName": "watchAggregateId"
        }, {
            "propName": "aggregateData",
            "methodName": "watchAggregateData"
        }]; }
    static get listeners() { return [{
            "name": "itemAggregate",
            "method": "itemAggregateHandler",
            "target": "window",
            "capture": false,
            "passive": false
        }]; }
}
