import { SubscriptionClient } from "subscriptions-transport-ws";
export class CustomSubscriptionClient extends SubscriptionClient {
    constructor(url, options, webSocketImpl, webSocketProtocols) {
        // It needs to be forced lazy otherwise it will try to connect before the setting up the following workaround
        super(url, Object.assign(Object.assign({}, options), { lazy: true }), webSocketImpl, webSocketProtocols);
        // Workaround suggested for ISSUE 377 on subscriptions-transport-ws package
        // https://github.com/apollographql/subscriptions-transport-ws/issues/377#issuecomment-375567665
        // @ts-ignore
        this.maxConnectTimeGenerator.setMin(this.maxConnectTimeGenerator.max);
        const { lazy = false } = options || {};
        if (!lazy) {
            // @ts-ignore
            this.connect();
        }
    }
}
