import { Component, Prop, h, Element } from "@stencil/core";
import { loadResponseElement } from "../../response-loader/response-loader";
/**
 * Renders a user's response to a question, without rendering the UI for the whole question.
 *
 */
export class PieResponse {
    render() {
        var _a;
        this.el.style.margin = '0px';
        if (!this.sessionData || !((_a = this.sessionData) === null || _a === void 0 ? void 0 : _a.itemConfig)) {
            return false;
        }
        const loaded = loadResponseElement("response", this.sessionData, this.el, this.multiPart);
        if (!loaded) {
            return h("slot", { name: "na" });
        }
    }
    static get is() { return "pie-response"; }
    static get properties() { return {
        "sessionData": {
            "type": "any",
            "mutable": false,
            "complexType": {
                "original": "any",
                "resolved": "any",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [{
                        "text": undefined,
                        "name": "internal"
                    }],
                "text": "The model of the response(s) to render.\nThis will be automaticaly set it the component is nested within a `pie-live-session` component.\nTODO - fix typing"
            },
            "attribute": "session-data",
            "reflect": false
        },
        "multiPart": {
            "type": "boolean",
            "mutable": false,
            "complexType": {
                "original": "boolean",
                "resolved": "boolean",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": "If multi-part items should be supported (render all parts)"
            },
            "attribute": "multi-part",
            "reflect": false
        }
    }; }
    static get contextProps() { return [{
            "name": "doc",
            "context": "document"
        }]; }
    static get elementRef() { return "el"; }
}
