const express = require("express");
const { createServer } = require("http");
const server = require("./server");
const startServer = async () => {
    const app = express();
    server.applyMiddleware({ app, path: "/" });
    const httpServer = createServer(app);
    server.installSubscriptionHandlers(httpServer);
    const serverPort = await new Promise((resolve, reject) => {
        httpServer
            .listen(process.env.PORT || 4000, () => {
            const { port } = httpServer.address();
            resolve(port);
        })
            .on("error", (error) => {
            console.error(`problem starting up live server: ${error}`);
            reject(error);
        });
    });
    console.log(`🚀 Server ready at ${serverPort}`);
    return serverPort;
};
startServer()
    .then(() => {
    console.log("mock server started");
})
    .catch((err) => {
    console.log(`Unable to start mock server: ${err}`);
});
