import { aggregatorTagMap, importWithFallback } from "./utils";
import { pieElementExtensionsUrl } from "../aggregates/constants";
const tagMap = {
    "@pie-element/calculator": 'calculator',
    "@pie-element/categorize": 'categorize',
    "@pie-element/charting": 'charting',
    "@pie-element/complex-rubric": 'complex-rubric',
    "@pie-element/drag-in-the-blank": 'drag-in-the-blank',
    "@pie-element/drawing-response": 'drawing-response',
    "@pie-element/ebsr": 'ebsr',
    "@pie-element/explicit-constructed-response": 'explicit-constructed-response',
    "@pie-element/extended-text-entry": 'extended-text-entry',
    "@pie-element/graphing": 'graphing',
    "@pie-element/graphing-solution-set": 'graphing-solution-set',
    "@pie-element/hotspot": 'hotspot',
    "@pie-element/image-cloze-association": 'image-cloze-association',
    "@pie-element/inline-dropdown": 'inline-dropdown',
    "@pie-element/match": 'match',
    "@pie-element/match-list": 'match-list',
    "@pie-element/math-inline": 'math-inline',
    "@pie-element/math-templated": 'math-templated',
    "@pie-element/multi-trait-rubric": 'multi-trait-rubric',
    "@pie-element/multiple-choice": 'multiple-choice',
    "@pie-element/number-line": 'number-line',
    "@pie-element/passage": 'passage',
    "@pie-element/placement-ordering": 'placement-ordering',
    "@pie-element/protractor": 'protractor',
    "@pie-element/rubric": 'rubric',
    "@pie-element/ruler": 'ruler',
    "@pie-element/select-text": 'select-text',
};
const pieResponsesMapping = {
    "@pie-element/categorize": {
        responseCell: `${pieElementExtensionsUrl}/CategorizeCell.js`,
        response: `${pieElementExtensionsUrl}/CategorizeResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/CategorizeAggregatesService.js`,
    },
    "@pie-element/charting": {
        responseCell: `${pieElementExtensionsUrl}/ChartingCell.js`,
        response: `${pieElementExtensionsUrl}/ChartingResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/ChartingAggregatesService.js`,
    },
    "@pie-element/explicit-constructed-response": {
        responseCell: `${pieElementExtensionsUrl}/ConstructedCell.js`,
        response: `${pieElementExtensionsUrl}/ConstructedResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/ExplicitConstructedResponseAggregatesService.js`,
    },
    "@pie-element/drag-in-the-blank": {
        responseCell: `${pieElementExtensionsUrl}/DragInTheBlankCell.js`,
        response: `${pieElementExtensionsUrl}/DragInTheBlankResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/DragInTheBlankAggregatesService.js`,
    },
    "@pie-element/drawing-response": {
        responseCell: `${pieElementExtensionsUrl}/DrawingCell.js`,
        response: `${pieElementExtensionsUrl}/DrawingResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/DrawingResponseAggregatesService.js`,
    },
    "@pie-element/ebsr": {
        responseCell: `${pieElementExtensionsUrl}/EBSRCell.js`,
        response: `${pieElementExtensionsUrl}/EBSRResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/EBSRAggregatesService.js`,
    },
    "@pie-element/extended-text-entry": {
        responseCell: `${pieElementExtensionsUrl}/ExtendedTextEntryCell.js`,
        response: `${pieElementExtensionsUrl}/ExtendedTextEntryResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/ExtendedTextEntryAggregatesService.js`,
    },
    "@pie-element/graphing": {
        responseCell: `${pieElementExtensionsUrl}/GraphingCell.js`,
        response: `${pieElementExtensionsUrl}/GraphingResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/GraphingAggregatesService.js`,
    },
    "@pie-element/hotspot": {
        responseCell: `${pieElementExtensionsUrl}/HotspotCell.js`,
        response: `${pieElementExtensionsUrl}/HotspotResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/HotspotAggregatesService.js`,
    },
    "@pie-element/inline-dropdown": {
        responseCell: `${pieElementExtensionsUrl}/InlineDropdownCell.js`,
        response: `${pieElementExtensionsUrl}/InlineDropdownResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/InlineDropdownAggregatesService.js`,
    },
    "@pie-element/match": {
        responseCell: `${pieElementExtensionsUrl}/MatchCell.js`,
        response: `${pieElementExtensionsUrl}/MatchResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/MatchAggregatesService.js`,
    },
    "@pie-element/match-list": {
        responseCell: `${pieElementExtensionsUrl}/MatchListCell.js`,
        response: `${pieElementExtensionsUrl}/MatchListResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/MatchListAggregatesService.js`,
    },
    "@pie-element/math-inline": {
        responseCell: `${pieElementExtensionsUrl}/MathInlineCell.js`,
        response: `${pieElementExtensionsUrl}/MathInlineResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/MathInlineAggregatesService.js`,
    },
    "@pie-element/multiple-choice": {
        responseCell: `${pieElementExtensionsUrl}/MultipleChoiceCell.js`,
        response: `${pieElementExtensionsUrl}/MultipleChoiceResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/MultipleChoiceAggregatesService.js`,
    },
    "@pie-element/number-line": {
        responseCell: `${pieElementExtensionsUrl}/NumberLineCell.js`,
        response: `${pieElementExtensionsUrl}/NumberLineResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/NumberLineAggregatesService.js`,
    },
    "@pie-element/placement-ordering": {
        responseCell: `${pieElementExtensionsUrl}/OrderingCell.js`,
        response: `${pieElementExtensionsUrl}/OrderingResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/PlacementOrderingAggregatesService.js`,
    },
    "@pie-element/select-text": {
        responseCell: `${pieElementExtensionsUrl}/SelectTextCell.js`,
        response: `${pieElementExtensionsUrl}/SelectTextResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/SelectTextAggregatesService.js`,
    },
    "@pie-element/image-cloze-association": {
        responseCell: `${pieElementExtensionsUrl}/ImageClozeAssociationCell.js`,
        response: `${pieElementExtensionsUrl}/ImageClozeAssociationResponse.js`,
        aggregator: `${pieElementExtensionsUrl}/ImageClozeAssociationAggregatesService.js`,
    },
    "empty": {
        responseCell: `${pieElementExtensionsUrl}/EmptyCell.js`,
        response: `${pieElementExtensionsUrl}/EmptyResponse.js`
    }
};
const pieResponsesBlackList = {
    "@pie-element/calculator": true,
    "@pie-element/complex-rubric": true,
    "@pie-element/graphing-solution-set": true,
    "@pie-element/math-templated": true,
    "@pie-element/multi-trait-rubric": true,
    "@pie-element/passage": true,
    "@pie-element/protractor": true,
    "@pie-element/rubric": true,
    "@pie-element/ruler": true,
};
/**
 * If `config.pies` definition is missing, this will generate defaults for pies in @pie-element scope
 * TODO - this should be deprecated once pie 'installation' is working in pie api, meaning configs shoud
 * have the `pies` definitions.
 *
 * @param elements the elements definitions
 */
export const polyfillPieElements = (elements) => {
    if (elements) {
        const pieDefs = Object.keys(elements).map(tag => {
            const { name } = parsePackage(elements[tag]);
            return Object.assign({
                elements: pieResponsesMapping[name],
                blackListed: pieResponsesBlackList[name] === true
            }, { tag: tagMap[name], aggregatorTag: aggregatorTagMap[name], 
                // we have to keep the used tag name to determine if the item can be rendered (check loadResponseElement) in case of multi-part
                modelElementName: tag });
        });
        return pieDefs;
    }
};
export const loadResponseElement = (elementName, sessionData, host, multiPart) => {
    var _a;
    if (!sessionData || !(sessionData === null || sessionData === void 0 ? void 0 : sessionData.itemConfig)) {
        return false;
    }
    // check if tag is defined as custom element, define it if it isn't.
    // check if tag is present as a child of host
    const pieConfig = sessionData.itemConfig.pie ? sessionData.itemConfig.pie : sessionData.itemConfig;
    if (!pieConfig.pies) {
        pieConfig.pies = polyfillPieElements(pieConfig.elements);
    }
    let found = 0;
    // host.shadowRoot.innerHTML = "";
    host.innerHTML = "";
    const { pies } = pieConfig;
    let models = ((_a = sessionData === null || sessionData === void 0 ? void 0 : sessionData.itemConfig) === null || _a === void 0 ? void 0 : _a.models) || [];
    // when there are multi-parts, the black listed item types should be not taken in
    // consideration in order to determine if an empty cell should be displayed or not
    const notBlackListedModels = pies && models.length && models.reduce((acc, model) => {
        const correspondingPie = pies.find(pie => pie.modelElementName === model.element);
        return acc + (!(correspondingPie.blackListed) ? 1 : 0);
    }, 0);
    pies && pies.forEach((pie) => {
        var _a;
        let elementSpecifier = ((_a = pie.elements) !== null && _a !== void 0 ? _a : {})[elementName];
        let tag = `${pie.tag}-${elementName}`.toLowerCase();
        // if multi-part, render an empty cell/response for the entire item
        if (!multiPart && notBlackListedModels > 1) {
            tag = `empty-tag-${elementName}`.toLowerCase();
            elementSpecifier = pieResponsesMapping.empty[elementName];
            models = [models[0]];
        }
        if (elementSpecifier) {
            found++;
            customElements.whenDefined(tag).then(() => {
                models.forEach(m => {
                    var _a;
                    const { blackListed } = pie;
                    // if item is multi-part, for example multiple-choice & rubric, if pie.modelElementName is multiple-choice, rubric does not have to be rendered at this point
                    if (m.element == pie.modelElementName && !blackListed) {
                        // const hostShadowRoot = host.shadowRoot;
                        const session = (_a = sessionData === null || sessionData === void 0 ? void 0 : sessionData.data) === null || _a === void 0 ? void 0 : _a.find(s => s.id === m.id);
                        // if (!hostShadowRoot) {
                        //     return;
                        // }
                        // let el: any = host.shadowRoot.querySelector(`${tag}[id="${m.id}"]`);
                        let el = host.querySelector(`${tag}[id="${m.id}"]`);
                        if (!el) {
                            const newEl = document.createElement(tag);
                            newEl.setAttribute('id', m.id);
                            // host.shadowRoot.appendChild(newEl);
                            host.appendChild(newEl);
                            el = newEl;
                        }
                        el.model = m;
                        el.session = session;
                    }
                });
            });
            if (!customElements.get(tag)) {
                importWithFallback(elementSpecifier).then(Module => {
                    if (!customElements.get(tag)) {
                        try {
                            customElements.define(tag, Module.default);
                        }
                        catch (domException) {
                            if (domException.name === 'NotSupportedError') {
                                if (customElements.get(tag)) {
                                    // not an error because el was defined elsewhere
                                    console.warn('handed domException element already defined');
                                }
                                else {
                                    console.error(`error defining element, error: ${domException.message}`);
                                }
                            }
                        }
                    }
                }).catch(err => {
                    console.error(err.toString());
                });
            }
        }
    });
    return (pies && pies.filter(pie => !pie.blackListed).length == found);
};
export const loadAggregator = async (itemConfig) => {
    if (!itemConfig) {
        return;
    }
    const pieConfig = itemConfig.pie ? itemConfig.pie : itemConfig;
    if (!pieConfig.pies) {
        pieConfig.pies = polyfillPieElements(pieConfig.elements);
    }
    const { pies } = pieConfig;
    const promises = [];
    const aggregatorTags = [];
    pies && pies.forEach((pie) => {
        var _a;
        const elementSpecifier = ((_a = pie.elements) !== null && _a !== void 0 ? _a : {})["aggregator"];
        const alreadySet = window[pie.aggregatorTag];
        const alreadyInPromises = aggregatorTags.indexOf(pie.aggregatorTag) >= 0;
        if (elementSpecifier && !alreadySet && !alreadyInPromises) {
            // here eroare
            promises.push(importWithFallback(elementSpecifier));
            aggregatorTags.push(pie.aggregatorTag);
        }
    });
    return await Promise.all(promises).then((values) => {
        values.forEach((Module, index) => window[aggregatorTags[index]] = Module.default);
        return true;
    }).catch(e => {
        console.error(e.toString());
        return false;
    });
};
const parsePackage = (input) => {
    const RE_SCOPED = /^(@[^/]+\/[^/@]+)(?:\/([^@]+))?(?:@([\s\S]+))?/;
    const RE_NORMAL = /^([^/@]+)(?:\/([^@]+))?(?:@([\s\S]+))?/;
    if (typeof input !== 'string') {
        throw new TypeError('Expected a string');
    }
    const matched = input.charAt(0) === '@' ? input.match(RE_SCOPED) : input.match(RE_NORMAL);
    if (!matched) {
        throw new Error(`[parse-package-name] "${input}" is not a valid string`);
    }
    return {
        name: matched[1],
        path: matched[2] || '',
        version: matched[3] || ''
    };
};
