export var SessionEventType;
(function (SessionEventType) {
    SessionEventType["SAVE"] = "save";
    SessionEventType["LOAD"] = "load";
    SessionEventType["MODEL"] = "model";
    SessionEventType["SCORE"] = "score";
    SessionEventType["MANUAL_SCORE"] = "manual-score";
})(SessionEventType || (SessionEventType = {}));
export class LoadSessionEvent {
    constructor(timestamp) {
        this.timestamp = timestamp;
        this.type = SessionEventType.LOAD;
    }
}
export class SaveSessionEvent {
    constructor(timestamp, data, _source) {
        this.timestamp = timestamp;
        this.data = data;
        this.type = SessionEventType.SAVE;
    }
}
export class ModelEvent {
    constructor(timestamp, env) {
        this.timestamp = timestamp;
        this.env = env;
        this.type = SessionEventType.MODEL;
    }
}
export class ManualScoreEvent {
    constructor(timestamp, score) {
        this.timestamp = timestamp;
        this.score = score;
        this.type = SessionEventType.MANUAL_SCORE;
    }
}
export class ScoreEvent {
    constructor(timestamp, score, mode = "evaluate") {
        this.timestamp = timestamp;
        this.score = score;
        this.mode = mode;
        this.type = SessionEventType.SCORE;
    }
}
export var ScoreType;
(function (ScoreType) {
    ScoreType["AUTO"] = "auto";
    ScoreType["MANUAL"] = "manual";
})(ScoreType || (ScoreType = {}));
