import { r as registerInstance, d as getContext, h, g as getElement } from './index-61a21509.js';
import './constants-fd932faf.js';
import { a as loadResponseElement } from './response-loader-49a04d04.js';

/**
 * Renders a user's response to a question in summary text form - not more than 32 characters.
 * This is intended for use in grid/spreadsheet style views.
 *
 * Not all PIE question types may support this feature, in that case no response will be rendered
 * and the attribute `not-available` will be added to the element.
 */
class PieResponseCell {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.doc = getContext(this, "document");
    }
    render() {
        var _a;
        this.el.style.margin = '0px';
        if (!this.sessionData || !((_a = this.sessionData) === null || _a === void 0 ? void 0 : _a.itemConfig)) {
            return false;
        }
        const loaded = loadResponseElement("responseCell", this.sessionData, this.el, this.multiPart);
        if (!loaded) {
            return h("slot", { name: "na" });
        }
    }
    get el() { return getElement(this); }
}

export { PieResponseCell as pie_response_cell };
