/* eslint-disable */
/* tslint:disable */
/**
 * This is an autogenerated file created by the Stencil compiler.
 * It contains typing information for all components that exist in this project.
 */
import { HTMLStencilElement, JSXBase } from "./stencil-public-runtime";
import { MetadataProperty } from "./types";
export namespace Components {
    interface ItemMetadata {
        /**
          * The key for the metadata value to look up for an item in pie-api
         */
        "_key": string;
        /**
          * The attribute name to use - the value returned for the metadat key will be placed in this attribute on child `<pie-live-session>` elements.
         */
        "attribute": string;
    }
    interface LoadingIndicator {
        "progressAmount": string;
        "progressColor": string;
    }
    interface PieAggregate {
        /**
          * The Aggregator Id to receive events to
         */
        "aggregateId": string;
    }
    interface PieApiLive {
        /**
          * The Assignment ID - REQUIRED in order to load any data
         */
        "assignmentId": string;
        /**
          * Boolean that determines if aggregates have to be calculated and emitted
         */
        "emitAggregates": boolean;
        /**
          * The pie-api-live host (environment) - used to determine live (subscriptions) hosts. One of: `dev`, `prod`.  e.g.: if host = 'dev' => webSocket connection to wss://live.dev.pie-api.com/api/graphql
         */
        "host": string;
        /**
          * The live server CUSTOM host. If present, overrides the live (subscriptions) server host.  e.g.: `wss://live.dev.pie-api.com/api/graphql
         */
        "liveUrl": string;
        /**
          * If loading indicator should show up while the item is loading.
         */
        "loadingIndicator": boolean;
        /**
          * An array of MetadataProperties to be extracted from Item and added to `pie-live-session` elements as attributes. If no value is found for the provided key on an item, the attribute will not be set. This property must be set before adding any child `<pie-live-session>` elements.  [    {      key:"metadata_key",      attribute: "attribute-name"    } ]  This property can alternatively be set declaritively in html using `<item-metadata key="foo" attribute-name="foo-value">` as a child element of `<pie-api-live>` before any `<pie-live-session>` elements.
         */
        "metadata": MetadataProperty[];
        "pageSize": number;
        /**
          * The api token for pie-api. The token must have the `live` scope.
         */
        "token": string;
    }
    interface PieLiveSession {
        /**
          * Used to set itemConfig and sessionData
         */
        "_itemAndSessionData": string;
        /**
          * The Aggregate Id to use
         */
        "aggregateId": string;
        /**
          * If loading indicator should show up while the item is loading
         */
        "loadingIndicator": boolean;
        /**
          * An array of MetadataProperties to be extracted from Item and added to `pie-live-session` elements as attributes. If no value is found for the provided key on an item, the attribute will not be set.
         */
        "metadata": MetadataProperty[];
        /**
          * The Item Session Id to watch
         */
        "sessionId": string;
    }
    interface PieResponse {
        /**
          * If multi-part items should be supported (render all parts)
         */
        "multiPart": boolean;
        /**
          * The model of the response(s) to render. This will be automaticaly set it the component is nested within a `pie-live-session` component. TODO - fix typing
         */
        "sessionData": any;
    }
    interface PieResponseCell {
        /**
          * If multi-part items should be supported (render all parts)
         */
        "multiPart": boolean;
        /**
          * The model of the response(s) to render. This will be automatically set it the component is nested within a `pie-live-session` component. TODO - fix typing
         */
        "sessionData": any;
    }
}
declare global {
    interface HTMLItemMetadataElement extends Components.ItemMetadata, HTMLStencilElement {
    }
    var HTMLItemMetadataElement: {
        prototype: HTMLItemMetadataElement;
        new (): HTMLItemMetadataElement;
    };
    interface HTMLLoadingIndicatorElement extends Components.LoadingIndicator, HTMLStencilElement {
    }
    var HTMLLoadingIndicatorElement: {
        prototype: HTMLLoadingIndicatorElement;
        new (): HTMLLoadingIndicatorElement;
    };
    interface HTMLPieAggregateElement extends Components.PieAggregate, HTMLStencilElement {
    }
    var HTMLPieAggregateElement: {
        prototype: HTMLPieAggregateElement;
        new (): HTMLPieAggregateElement;
    };
    interface HTMLPieApiLiveElement extends Components.PieApiLive, HTMLStencilElement {
    }
    var HTMLPieApiLiveElement: {
        prototype: HTMLPieApiLiveElement;
        new (): HTMLPieApiLiveElement;
    };
    interface HTMLPieLiveSessionElement extends Components.PieLiveSession, HTMLStencilElement {
    }
    var HTMLPieLiveSessionElement: {
        prototype: HTMLPieLiveSessionElement;
        new (): HTMLPieLiveSessionElement;
    };
    interface HTMLPieResponseElement extends Components.PieResponse, HTMLStencilElement {
    }
    var HTMLPieResponseElement: {
        prototype: HTMLPieResponseElement;
        new (): HTMLPieResponseElement;
    };
    interface HTMLPieResponseCellElement extends Components.PieResponseCell, HTMLStencilElement {
    }
    var HTMLPieResponseCellElement: {
        prototype: HTMLPieResponseCellElement;
        new (): HTMLPieResponseCellElement;
    };
    interface HTMLElementTagNameMap {
        "item-metadata": HTMLItemMetadataElement;
        "loading-indicator": HTMLLoadingIndicatorElement;
        "pie-aggregate": HTMLPieAggregateElement;
        "pie-api-live": HTMLPieApiLiveElement;
        "pie-live-session": HTMLPieLiveSessionElement;
        "pie-response": HTMLPieResponseElement;
        "pie-response-cell": HTMLPieResponseCellElement;
    }
}
declare namespace LocalJSX {
    interface ItemMetadata {
        /**
          * The key for the metadata value to look up for an item in pie-api
         */
        "_key"?: string;
        /**
          * The attribute name to use - the value returned for the metadat key will be placed in this attribute on child `<pie-live-session>` elements.
         */
        "attribute"?: string;
    }
    interface LoadingIndicator {
        "progressAmount"?: string;
        "progressColor"?: string;
    }
    interface PieAggregate {
        /**
          * The Aggregator Id to receive events to
         */
        "aggregateId"?: string;
    }
    interface PieApiLive {
        /**
          * The Assignment ID - REQUIRED in order to load any data
         */
        "assignmentId"?: string;
        /**
          * Boolean that determines if aggregates have to be calculated and emitted
         */
        "emitAggregates"?: boolean;
        /**
          * The pie-api-live host (environment) - used to determine live (subscriptions) hosts. One of: `dev`, `prod`.  e.g.: if host = 'dev' => webSocket connection to wss://live.dev.pie-api.com/api/graphql
         */
        "host"?: string;
        /**
          * If loading indicator should show up while the item is loading.
         */
        "loadingIndicator"?: boolean;
        /**
          * An array of MetadataProperties to be extracted from Item and added to `pie-live-session` elements as attributes. If no value is found for the provided key on an item, the attribute will not be set. This property must be set before adding any child `<pie-live-session>` elements.  [    {      key:"metadata_key",      attribute: "attribute-name"    } ]  This property can alternatively be set declaritively in html using `<item-metadata key="foo" attribute-name="foo-value">` as a child element of `<pie-api-live>` before any `<pie-live-session>` elements.
         */
        "metadata"?: MetadataProperty[];
        /**
          * Emitted when an aggregate has been recalculated
         */
        "onItemAggregate"?: (event: CustomEvent<any>) => void;
        /**
          * Emitted when there's a new item in the assignment
         */
        "onNewItemInAssignment"?: (event: CustomEvent<any>) => void;
        /**
          * Emitted when there's a new session in the assignment
         */
        "onNewSessionInAssignment"?: (event: CustomEvent<any>) => void;
        "pageSize"?: number;
        /**
          * The api token for pie-api. The token must have the `live` scope.
         */
        "token"?: string;
    }
    interface PieLiveSession {
        /**
          * The Aggregate Id to use
         */
        "aggregateId"?: string;
        /**
          * If loading indicator should show up while the item is loading
         */
        "loadingIndicator"?: boolean;
        /**
          * Emitted when the element is first connected to the DOM.
         */
        "onAttachSession"?: (event: CustomEvent<any>) => void;
        /**
          * Emitted when an event has been received for this session.
         */
        "onEventReceived"?: (event: CustomEvent<any>) => void;
        /**
          * The Item Session Id to watch
         */
        "sessionId"?: string;
    }
    interface PieResponse {
        /**
          * If multi-part items should be supported (render all parts)
         */
        "multiPart"?: boolean;
    }
    interface PieResponseCell {
        /**
          * If multi-part items should be supported (render all parts)
         */
        "multiPart"?: boolean;
    }
    interface IntrinsicElements {
        "item-metadata": ItemMetadata;
        "loading-indicator": LoadingIndicator;
        "pie-aggregate": PieAggregate;
        "pie-api-live": PieApiLive;
        "pie-live-session": PieLiveSession;
        "pie-response": PieResponse;
        "pie-response-cell": PieResponseCell;
    }
}
export { LocalJSX as JSX };
declare module "@stencil/core" {
    export namespace JSX {
        interface IntrinsicElements {
            "item-metadata": LocalJSX.ItemMetadata & JSXBase.HTMLAttributes<HTMLItemMetadataElement>;
            "loading-indicator": LocalJSX.LoadingIndicator & JSXBase.HTMLAttributes<HTMLLoadingIndicatorElement>;
            "pie-aggregate": LocalJSX.PieAggregate & JSXBase.HTMLAttributes<HTMLPieAggregateElement>;
            "pie-api-live": LocalJSX.PieApiLive & JSXBase.HTMLAttributes<HTMLPieApiLiveElement>;
            "pie-live-session": LocalJSX.PieLiveSession & JSXBase.HTMLAttributes<HTMLPieLiveSessionElement>;
            "pie-response": LocalJSX.PieResponse & JSXBase.HTMLAttributes<HTMLPieResponseElement>;
            "pie-response-cell": LocalJSX.PieResponseCell & JSXBase.HTMLAttributes<HTMLPieResponseCellElement>;
        }
    }
}
