/**
 * Renders a user's response to a question in summary text form - not more than 32 characters.
 * This is intended for use in grid/spreadsheet style views.
 *
 * Not all PIE question types may support this feature, in that case no response will be rendered
 * and the attribute `not-available` will be added to the element.
 */
export declare class PieResponseCell {
    doc: Document;
    el: HTMLElement;
    /**
     * The model of the response(s) to render.
     * This will be automatically set it the component is nested within a `pie-live-session` component.
     * TODO - fix typing
     * @internal
     */
    sessionData: any;
    /**
     * If multi-part items should be supported (render all parts)
     */
    multiPart: boolean;
    render(): any;
}
