
# PIE LIve Api Components

A set of components for interacting with PIE Api Live, for realtime reporting on user assessment item sessions.

See Readme docs for each component:

[pie-api-live](./pie-api-live/readme.md)






## devt

ron locally in devt mode

```bash
npm install
npm start
```

To build the component for production, run:

```bash
npm run build
```

To run the unit tests for the components, run:

```bash
npm test
```

### Debug 

To run mock server in debug mode:

```
node --inspect -r ts-node/register src/mock-server/start-mock-server.ts
```

To run debugger on one stencil spec test file for one test:
```
 node --inspect-brk -r ts-node/register ./node_modules/.bin/stencil test --spec  src/components/pie-live-session/pie-live-session.spec.ts -t metadata
```
Then attach VSCode / Chrome debugger.

There is also a 'spec test current file' launch config for vscode in the repository.

## TODO / Notes

> load scoring browser modules with session? issue is if getting scores outside of waiting for a score event

This would require re-purposing/re-implementing the item level scoring function from pie-api?

> dealing with multi-part

Will handle this internally in the response-rendering components, if there are multi-parts can append mulitple explicit elements like `<response-part>` we may need to look at expliciti definition of what a part is at core model level, maybe props all pies can use in their model to define themselves as a part, with a label etc 
 - what if multiple pies where not all are 'parts'? need more explicit definition of parts? In short term can use models references in response model on save to determine what is a 'part' based on there being a saved 'response' for that pie.


live-session should retrieve item model directly once using item id (rather than receiving model in every sessionEvent as it is now. For short-term in R&D this is ok, but should be refactored for efficiency
